#!/usr/bin/php
<?php

$PATH_LICENCE_PRIV_KEY='/etc/esia/licence/id_rsa';
$PATH_LICENCE_PUB_KEY='/etc/esia/licence/id_rsa.pub';
$PATH_LICENCE_CHECK="/usr/local/esia/licence/validate_licence";

$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
$ARRAY_GROUP= array();

include_once '/usr/local/esia/public_html/esia.conf.php';
include_once '/usr/local/esia/public_html/Model_esia.php';
include_once "/usr/local/esia/public_html/api/client/client.class.php";

//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}
$licence = Model_esia::getLicenceInformation($dbconnection);
//print_r($licence);
$now = new DateTime();
$time = $now->getTimestamp();

if( $licence['type'] == 'Mercury' &&  $licence['expire'] < $time)
{
    exec($PATH_LICENCE_CHECK,$output,$ret);
    if($ret!=0)
    {
        echo "BAD LICENCE\n";
        exit(1);
    }
    $sql = "SELECT conso_device_id,conso_node, extract(EPOCH FROM ( NOW() - conso_last_update))::int as last_update FROM esia_consumption;";
    $query = $dbconnection->prepare($sql);
    $query->execute();
    $allconso=array();
    $global_maxnode=$licence['node'];
    $total=0;
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $allconso[$row->conso_device_id]=array('node'=>$row->conso_node,'last_update'=>$row->last_update);
        $total=$total + $row->conso_node;
    }
    $global_maxnode = $global_maxnode - $total;
    $query_insert = "INSERT INTO esia_consumption(conso_node,conso_device_id,conso_last_update) VALUES (?, ?,NOW());";
    $query_update = "UPDATE esia_consumption SET conso_node=?,conso_last_update=NOW() WHERE conso_device_id=?;";
    $query_select = "SELECT conso_max_node FROM esia_consumption WHERE conso_device_id=?;";
//	echo "ici";
//	print_r($allconso);
    $query_insert = $dbconnection->prepare($query_insert);
    $query_update = $dbconnection->prepare($query_update);
    $query_select = $dbconnection->prepare($query_select);
    $sql =" SELECT device_id,device_config_type_name,adv_param,adv_authfile_crypt,adv_plugin_keyword_value
                FROM esia_device 
                JOIN esia_device_advance_config ON device_id = adv_device_id
                JOIN esia_device_advance_config_type ON device_config_type_id = adv_config_type_id
                WHERE device_config_type_name='API'";
    $query = $dbconnection->prepare($sql);
    $query->execute();
        
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $node = Model_esia::InstanceNode($dbconnection,$row->device_id);
        $file = fopen($row->adv_plugin_keyword_value, "r");
        if(!$file)
        {
	    continue;
          //  throw new Exception("can't open file:".$row->adv_plugin_keyword_value);
        }
        $buffer="";
        while (($line = fgets($file)) !== false) 
        {
            $buffer.=$line;
        }
        fclose($file);
        $auth = json_decode($buffer,true);
        $output="";
        try
        {
                echo "Connect to ".str_pad($node->getName(),40)." : ";
                $client = new ClientApi();
                $client->authentication($auth['url'],$auth['username'],$auth['password'],$auth['port']);
                $state = $client->get('state');
                if(array_key_exists($node->getId(),$allconso))
                {
                    $query_update->execute(array($state['total_node'],$node->getId()));
                    $query_select->execute(array($node->getId())); 
                    $fixenode=$query_select->fetch(PDO::FETCH_OBJ);
                    $fixenode = $fixenode->conso_max_node;
                    $now = new DateTime();
                    $time = $now->getTimestamp();
                    $lic = $client->get('license');
                    if(empty($lic['expire']) || $fixenode==-1)
				    {
		            	$query_insert->execute(array($state['total_node'],$node->getId()));
		                exec($PATH_LICENCE_CHECK." -p ".$PATH_LICENCE_PUB_KEY." -k ".$PATH_LICENCE_PRIV_KEY.' -g Mercury-client -n '.$global_maxnode ,$output,$ret);
		                $licence = "";
		                foreach($output as $line)
		                {
		                	$licence .= $line."\n";
		               	}
		                $client->post('license',array('license'=>$licence));
		                $client->logout();
				   } 
				   else
				   {
                        $expire = $lic['expire'] - $time;
                        $flag_update = false;
                        if( $lic['max_nodes'] != $fixenode)
                        {
                            $flag_update=true;
                        }
                        if($expire < 2592000)
                        {
                            $flag_update=true;
                        }
                        if($flag_update == true)
                        {
                            echo " Renew licence fixed $fixenode";
                            exec($PATH_LICENCE_CHECK." -p ".$PATH_LICENCE_PUB_KEY." -k ".$PATH_LICENCE_PRIV_KEY.' -g Mercury-client -n '.$fixenode ,$output,$ret);
                            $licence = "";
                            foreach($output as $line)
                            {
                                $licence .= $line."\n";
                            }
                            $client->post('license',array('license'=>$licence));
                            $client->logout();
                        }
                    }
                }
                else
                {
	            	echo " Renew Licence ";
                    $query_insert->execute(array($state['total_node'],$node->getId()));
                    exec($PATH_LICENCE_CHECK." -p ".$PATH_LICENCE_PUB_KEY." -k ".$PATH_LICENCE_PRIV_KEY.' -g Mercury-client -n '.$global_maxnode ,$output,$ret);
                    $licence = "";
                    foreach($output as $line)
                    {
                        $licence .= $line."\n";
                    }
                    $client->post('license',array('license'=>$licence));
                    $client->logout();
                }
                echo "SUCCESS\n";
        }
        catch(Exception $e)
        {
            echo" FAILED ".$e->getMessage()."\n";
        }
    }
}
else
{
	echo" ERR Bad licence type or licence is expired\n";
}
exit(0);
?>
